from os import times
import threading
import serial
import time
import sys
import subprocess

serialPort = "/dev/ttyACM0"
tty = None

def openSerial():
    global tty

    tty = serial.Serial()
    tty.port = serialPort
    tty.baudrate = 115200
    tty.bytesize = serial.EIGHTBITS
    tty.parity = serial.PARITY_NONE
    tty.stopbits = serial.STOPBITS_ONE
    tty.xonxoff    = False
    tty.rtscts     = False
    tty.dsrdtr     = False
    tty.rs485_mode = None
    tty.timeout    = 0.2
    tty.open()

def runInBG(stop):
    while not stop:
        tty.write("#IIA\r\n".encode("utf-8"))

        time.sleep(1)

def waitForGD() -> bool:
    timeout = 0
    while True:
        # print(".", end="", flush=True)
        # tty.write("#SPC:100:0:0:0\r\n".encode("utf-8"))

        avail = tty.in_waiting
        if avail>0:
            # print("")
            return True

        timeout = timeout + 1
        if timeout > 40:        # 2 sec
            # print("")
            return False

        time.sleep(1)


if __name__ == "__main__":
    # print("Opening serial port")
    openSerial()
    # print("Serial port opened")

    tty.reset_output_buffer()
    
    # print("Waiting for GD to come alive")
    if not waitForGD():
        # print("GD never got ready")
        tty.close()
        sys.exit(1)
    # print("GD ready")

    # Start the heartbeat
    # print("Starting heartbeat thread")
    stopHB = False
    th = threading.Thread(target=runInBG, args=[lambda: stopHB])
    th.start()


    while True:                                          
        # print(".", end="", flush=True)   
        tty.write("#QDI:0\r\n".encode("utf-8"))
                                                         
        avail = tty.in_waiting                           
        if avail>0:                        
            ttyData = tty.read(avail)
            ttyData = ttyData.decode()
            if ttyData[0:5] == "#QDI:":
                lines = ttyData.split("\n")
                for v in lines:
                    if len(v) > 7 and v[0:5] == "#QDI:":
                        v=v[7:].strip()
                        print(v, end="")
                        break
                break

    # Stop heartbeat thread
    stopHB = True
    th.join()
    th = None
    
    tty.close()


